#!/bin/perl
#!/usr/bin/perl
# this is a script version of LCM, finding all frequent itemsets

$ARGC = @ARGV;
if ( $ARGC < 1 ){
  printf ("lcm1.pl: threshold [separator] < input-file > output-file\n");
  exit (1);
}

$sigma = $ARGV[0];
$sep = " ";
if ( $ARGC >= 2 ){ $sep = $ARGV[1]; } 

# input the database, and remove newline code
# at the same time, construct Occ(emptyset)
$Dsiz = 0;
while (<STDIN>){
  chomp;
  @transaction = split($sep, $_);
  foreach $item( @transaction ) { push ( @{$D[$Dsiz]}, $item); }
  $global_Occ[$Dsiz] = $Dsiz;
  $Dsiz++;
}

@itemset = (); %Occs; $lev = 1; $cur_frq = $Dsiz;
iter ( \@global_Occ, "" );




sub iter{
  my ($Occ, $item ) = @_;

# print "itemset: item= $item, itemset=$#itemset: @itemset   Occ= @$Occ \n";

    # in recursive call of not a start level, compute the frequency of
    # each item and construct a conditional database by using Occ
    # (occurrence of the current itemset).
  occ_deliv ( \@$Occ, $item );

  print "@itemset ($cur_frq)\n";
  
  if ( $#itemset >= 0 ){
      # sort the items by their frequencies
    @{$jump[$lev]} = sort{$item_order{$a} <=> $item_order{$b}} @{$jump[$lev]};
  } else {
      # determine the item ordering by decreasing order of frequency and
      # sort the items in each transaction in the order
    sort_dat();
  }
  
#  $flag[$lev] = 0;
  foreach $i( @{$jump[$lev]} ) {
    $cur_frq = $#{$Occs{$i}}+1;
    if ( $cur_frq >= $sigma ){
      push ( @itemset, $i );
#      if ( $flag[$lev]==0 ){ print "@itemset ($cur_frq)\n"; $flag[$lev] = 1; }
#      else {
        $lev++;
        iter ( \@{$Occs{$i}}, $i );
        $lev--;
#      }
      $i = pop ( @itemset );
    }
    delete ( $Occs{$i} );
  }

    # clear the memory used in this iteration.
  undef ( @{$jump[$lev]} );
}

# sort items of each transaction according to their frequencies 
sub sort_dat{
    # sort all items
  @{$jump[1]} = sort{$#{$Occs{$b}} <=> $#{$Occs{$a}}} @{$jump[1]};
  
    # make item ordering array
  $i=0; foreach (@{$jump[1]} ){
    $item_order{$_} = $i;
    $i++;
  }
  
    # sort each transaction by item ordering array
  $i=0;
  foreach ( @D ) {
    @{$D[$i]} = sort{$item_order{$a} <=> $item_order{$b}} @{$_};
    $i++;
  }
}

# compute the occurrences of all large items, and
# collect items with non-zero frequencies in jump[lev].
sub occ_deliv{
  my ($Occ, $end ) = @_;
  foreach $tID( @$Occ ) {
    foreach $item( @{$D[$tID]} ) {
      if ( $item eq $end ){ last; }
      if ( !exists($Occs{$item}) ){ push ( @{$jump[$lev]}, $item ); }
      push (@{$Occs{$item}}, $tID);
    }
  }
}



